package de.mutschler.rpdl;

import java.text.*;
import java.util.Locale;
import de.mutschler.util.LString;

/**
 * This class contains the global configuration for RPDL
 */

public class RpdlConfig
{
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------
	
	/** The single instance of the config. */
	private static RpdlConfig cfg = null;
	
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------
	/**
	 * Get an Instance of this class.
	 */
	public static RpdlConfig getConfig() {
		if (cfg == null) {
			cfg = new RpdlConfig();
		}
		return cfg;
	}
	
	//----------------------------------------------------------------------
	//------- Methods
	//----------------------------------------------------------------------
	
	private DateFormat df = new SimpleDateFormat("dd.MM.yyyy");
	/**
	 * Get a formatter for a date. The default setting is "dd.MM.yyyy".
	 */
	public final DateFormat getDateFormat() {return df;}
	
	
	private Locale currentLocale = Locale.getDefault();
	public final Locale getLocale() {return currentLocale;}
	public final void setLocale(Locale l) {currentLocale = l;LString.setLocale(l);}
}