package de.mutschler.rpdl.basicvalue;

import de.mutschler.rpdl.entity.RpdlObject;

public class ValueObject extends BasicValue implements java.io.Serializable
{
	static final long serialVersionUID = 2905439337377656263L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------

	/** Here the actual value is stored */
	private RpdlObject value;
	
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------
	public ValueObject() {}
	
	public ValueObject (RpdlObject obj) {
		super();
		if (obj == null)
			throw new RuntimeException("cannot create ValueObject with empty object");
		value = obj;
	}
	
	//----------------------------------------------------------------------
	//------- Methods
	//----------------------------------------------------------------------
	
	/** The name of this type. */
	public static final String TYPENAME="OBJECT";
	/** The name of this type. */
	public String getType() {return TYPENAME;}
	
	/** Return the cast operation for casting into the same value type. */
	public int getCastOp() {throw new RuntimeException("error");}

	/** Get the actual value of this type. */
	public RpdlObject getValue() {return value;}
	
	/** Get a string-representation of the value. This is used for concatenation. */
	public String getStringValue() {return "OBJECT " + value.getName();}
	
	//----------------------------------------------------------------------
	//------- mathematical operations
	//----------------------------------------------------------------------

	/** Perform a calculation. */
	public BasicValue calculate(int op, BasicValue t) throws RpdlConversionException
	{
		return super.calculate(op, t);
	}

	/**
	 * For the static type-checking. Return the expected type for an
	 * operation.
	 */
	public String getResultType(int op, String type) {
		return super.getResultType(op, type);	// let the superclass return the error
	}
	
	
	//----------------------------------------------------------------------
	//------- overridden methods
	//----------------------------------------------------------------------
	/** Create a copy of this object */
	public Object clone() {return new ValueObject(value);}
		
}