package de.mutschler.rpdl.command;

import de.mutschler.rpdl.*;
import de.mutschler.rpdl.entity.*;
import de.mutschler.rpdl.basicvalue.*;
import de.mutschler.rpdl.statement.Stmt;
import java.util.*;
import java.text.*;

public class CmdCreateObjectFromLib extends RpdlCommand implements java.io.Serializable
{
	static final long serialVersionUID = 4572996758925129778L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------

	private String name;
	private String libName;

	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	/** A create object command.
	 * @param name the name of the object
	 * @param types a list of types for the object
	 */
	public CmdCreateObjectFromLib(String name, String libName)
	{
		this.name = name;
		this.libName = libName;
	}

	//----------------------------------------------------------------------
	//------- Overridden methods
	//----------------------------------------------------------------------
	/** Perform the actions when added to the main RPDL object.
	 */
	//----------------------------------------------------------------------
	//------- Overridden methods
	//----------------------------------------------------------------------
	/** Perform the actions when added to the main RPDL object.
	 */
	public void add(RpdlBase main) throws RpdlException
	{
		debug("Creating Object '" + name + "' from library object '" + libName + "'");
		try {
			// create the object
			RpdlObject lo = main.getLibObject(libName);
			if (lo == null)	
				throw new RpdlException("Object '" + libName + "' doesn't exist in the object library", getOrigin());
			RpdlObject ro = new RpdlObject(lo, main, name);
			ro.setOrigin(getOrigin());
			main.addObject(ro);
		} catch (RpdlException re) {
			re.fillOrigin(getOrigin());	// update origin if necessary
			throw re;
		}
	}

	public String toString() {
		return "CmdCreateObjectFromLib: CREATE OBJECT " + name + " FROM LIBRARY " + libName;
	}
}