package de.mutschler.rpdl.command;

import de.mutschler.rpdl.*;
import java.util.*;
import java.text.*;

public class CmdHistory extends RpdlCommand implements java.io.Serializable
{
	static final long serialVersionUID = 8952682750869032074L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------

	private RpdlHistoryEntry hEntry;
	private String date;
	private String title;
	private String text;
	
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	public CmdHistory(String date, String title, String text)
	{
		this.date = date;
		this.title = title;
		this.text = text;
	}

	//----------------------------------------------------------------------
	//------- Overridden methods
	//----------------------------------------------------------------------

	/** Perform the actions when added to the main
	 * RPDL object.
	 */
	public void add(RpdlBase main) throws RpdlException
	{
		try {
			hEntry = new RpdlHistoryEntry(RpdlConfig.getConfig().getDateFormat().parse(date), title, text);
			main.addHistoryEntry(hEntry);
		} catch (ParseException e) {
			throw new RpdlException("Error parsing date in command-block: " + date, getOrigin());
/*		} catch (RpdlException re) {
			re.fillOrigin(getOrigin());	// update origin if necessary
			throw re;
*/		}
	}
	
	public String toString() {
		return "CmdHist: " + hEntry;
	}
}