package de.mutschler.rpdl.entity;

import de.mutschler.rpdl.*;
import de.mutschler.util.LogObj;
import java.util.*;

/**
 * The superclass for all objects which contain a name.
 * e.g. RpdlAttribute, RpdlObject, RpdlTable, ...
 */

public abstract class NamedObj extends LogObj
{
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------

	/** The name of the attribute */
	private String name;

	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------
	public NamedObj(String name) {
		this.name = name;
    }
	
	//----------------------------------------------------------------------
	//------- Accessors
	//----------------------------------------------------------------------
	
	/** Get the name of the object. */
	public final String getName() {return name;}
	
	//----------------------------------------------------------------------
	//------- Origin handling
	//----------------------------------------------------------------------
	
	private Origin origin = null;
	/** Get the origin of this command. */
	public Origin getOrigin() {return origin;}
	/** Set the origin of this command. */
	public void setOrigin(Origin o) {origin=o;}
	
	//----------------------------------------------------------------------
	//------- Overridden system methods
	//----------------------------------------------------------------------
	
}