package de.mutschler.rpdl.statement;

import java.util.*;
import de.mutschler.rpdl.entity.RpdlFormula;
import de.mutschler.util.StringUtil;

public class Stmt_Cond extends Stmt_BoolFormula implements java.io.Serializable
{
	static final long serialVersionUID = -3954153222428656495L;
	//----------------------------------------------------------------------
	//------- Attributes
	//----------------------------------------------------------------------
	
	/** List of statements to execute when the formula result to true. */
	private List trueStmts = new LinkedList();
	/** List of statements to execute when the formula result to false. */
	private List falseStmts = new LinkedList();
	
	//----------------------------------------------------------------------
	//------- Constructor(s)
	//----------------------------------------------------------------------

	/**
	 * Create a new set statement. This checks, of the result
	 * is of boolean type.
	 * @param formula the formula to calculate
	 */

	public Stmt_Cond(RpdlFormula formula) {
		super(formula);
	}

	//----------------------------------------------------------------------
	//------- Accessors
	//----------------------------------------------------------------------
	
	/** Set the list of true statements. */
	public void setTrueStatements(List stmts) {stmts.remove(null); trueStmts = stmts;}
	/** Set the list of false statements. */
	public void setFalseStatements(List stmts) {stmts.remove(null); falseStmts = stmts;}

	//----------------------------------------------------------------------
	//------- Overridden system methods
	//----------------------------------------------------------------------
	
	public String toString() {
		StringBuffer sb = new StringBuffer(200);
		sb.append("IF (" + getFormula() + ") {\n");
		for (Iterator it = trueStmts.iterator(); it.hasNext(); ) {
			sb.append(StringUtil.indent(((Stmt)it.next()).toString()));
			sb.append('\n');
		}
		sb.append("}");
		if (!falseStmts.isEmpty()) {
			sb.append(" ELSE {\n");
			for (Iterator it = falseStmts.iterator(); it.hasNext(); ) {
				sb.append(StringUtil.indent(((Stmt)it.next()).toString()));
				sb.append('\n');
			}
			sb.append("}");
		}
		return sb.toString();
	}
}